%global momorel 2

Summary: Creates an initial ramdisk image for preloading modules.
Name: mkinitrd
Version: 3.5.22
Release: %{momorel}m
License: GPL
Group: System Environment/Base
Source: mkinitrd-%{version}.tar.bz2
Patch0: mkinitrd-3.5.22-momonga.patch
Patch1: mkinitrd-3.5.22-sysfs.patch
Patch2: mkinitrd-3.5.22-insmod.static.old.patch
#Patch101: mkinitrd-3.4.43-allocsize.patch
#Patch102: mkinitrd-3.4.43-lilo.patch
#Patch103: mkinitrd-3.4.43-posix.patch
#Patch104: mkinitrd-3.4.43-lvm-devfs.patch
#Patch106: mkinitrd-3.4.43-kernel26-modext.patch
#Patch107: mkinitrd-3.4.43-mkbsinitrd.patch
ExclusiveOs: Linux
Prereq: dev
Requires: e2fsprogs, bash, fileutils, grep, mount, gzip, tar, modutils, losetup, mktemp >= 1.4-2k, findutils
Requires: filesystem >= 2.1.0
BuildRequires: popt
%ifarch %{ix86} alpha
BuildPreReq: dietlibc
%endif
%ifarch ppc
Requires: ppc64-utils >= 0.3-1
%endif
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
Mkinitrd creates filesystem images for use as initial ramdisk (initrd)
images.  These ramdisk images are often used to preload the block
device modules (SCSI or RAID) needed to access the root filesystem.

In other words, generic kernels can be built without drivers for any
SCSI adapters which load the SCSI driver as a module.  Since the
kernel needs to read those modules, but in this case it isn't able to
address the SCSI adapter, an initial ramdisk is used.  The initial
ramdisk is loaded by the operating system loader (normally LILO) and
is available to the kernel as soon as the ramdisk is loaded.  The
ramdisk image loads the proper SCSI adapter and allows the kernel to
mount the root filesystem.  The mkinitrd program creates such a
ramdisk using information found in the /etc/conf.modules file.

%prep
%setup -q
%patch -p1 -b .momonga
%patch1 -p1 -b .sysfs
%patch2 -p1 -b .insmod.static.old

#%%patch101 -p1 -b .allocsize~
#%%patch102 -p1 -b .lilo~
#%%patch103 -p1 -b .posix2~
#%%patch104 -p1 -b .lvm-devfs~
#%%patch106 -p1 -b .kernel26-modext~
#%%patch107 -p1 -b .mkbsinitrd~

%build
make
make test
if [ $? != 0 ]; then exit 1; fi
 
%install
rm -rf %{buildroot}
make BUILDROOT=%{buildroot} mandir=%{_mandir} install
%ifarch ppc
rm -f %{buildroot}/usr/share/man/man8/grubby.8
rm -f %{buildroot}/sbin/grubby 
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%attr(755,root,root) /sbin/mkinitrd
%attr(644,root,root) %{_mandir}/man8/mkinitrd.8*
%attr(755,root,root) /sbin/nash
%attr(644,root,root) %{_mandir}/man8/nash.8*
%config %attr(755,root,root) /sbin/installkernel
%attr(755,root,root) /sbin/new-kernel-pkg
%attr(755,root,root) /sbin/grubby
%attr(644,root,root) %{_mandir}/man8/grubby.8*

%changelog
* Thu Aug  5 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (3.5.22-2m)
- disable mount/umount /sys at kernel-2.4

* Sun Jul 25 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (3.5.22-1m)
- upgrade

* Mon Jun 21 2004 mutecat <mutecat@momonga-linux.org>
- (3.4.49-11m)
- add %ifarch ppc

* Sun May  9 2004 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.49-10m)
- create initrd for bootsplash

* Mon Dec 15 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-9m)
- search .ko if kernel is 2.6.*

* Wed Dec 10 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-8m)
- for module-init-tools

* Sun Jun 15 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-7m)
- revise mkinitrd-3.4.43-lvm-devfs.patch

* Wed Jun 11 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-6m)
- fix mkinitrd to create initrd on lvm and devfs environment

* Mon May 12 2003 kourin <kourin@fh.freeserve.ne.jp>
- (3.4.43-5m)
- remove Requires: tetex (Iranuwa, boke! :p )

* Mon May 12 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-4m)
- fix typo in mkinitrd-3.4.43-lilo.patch

* Mon May 12 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-3m)
- tail -1 -> tail -n 1 (mkinitrd-3.4.43-posix.patch)

* Sun May 11 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-2m)
- new-kernel-pkg: skip lilo if /boot/boot.b does not exist

* Thu May  8 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.43-1m)
- sync with mkinitrd-3.4.43-1(rawhide)

* Tue Feb  4 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.4.33-2m)
- add mkinitrd-momonga.patch("Red Hat" -> "Momonga")

* Sat Jan  4 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (3.4.33-1m)
- version 3.4.33

* Tue Oct 22 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (3.3.10-6m)
- add mkinitrd-3.3.10-nashforce.patch to enable nash --force

* Mon Oct 14 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (3.3.10-5m)
- add mkinitrd-3.3.10-dietlibc.patch and
  add BuildPrereq: dietlibc on alpha

* Tue Oct  1 2002 Kazuhiko <kazuhiko@fdiary.net>
- (3.3.10-4m)
- 'BuildPreReq: dietlibc' on %{ix86} only

* Mon Sep 30 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (3.3.10-3m)
- add BuildPreReq: dietlibc

* Mon May 13 2002 Toru Hoshina <t@kondara.org>
- (3.3.10-2k)
- ver up.
- We don't use old anaconda anymore.

* Thu Feb 21 2002 Tsutomu Yasuda <tom@kondara.org>
- (3.0.9-30k)
- changed the Requires on mktemp from >= 1.5-5 to >= 1.4-2k

* Thu Jan 24 2002 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-28k)
- fix for new xfs 2002-01-23

* Mon Jan 14 2002 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-26k)
- fix for new xfs patch

* Tue Nov 20 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-24k)
- T_T

* Mon Nov 19 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-22k)
- add mkinitrd-3.0.9-robust.patch

* Sat Oct 27 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-20k)
- revert from 3.2.1?, because installer can not treat new mkinitrd
- AGERUNA KIKEN!

* Fri Sep 28 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-18k)
- add mkinitrd-3.0.9-large-imagesize.patch for large modules, especially xfs...

* Fri Sep 28 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-16k)
- add mkinitrd-3.0.9-xfs.patch for xfs filesystem

* Thu Sep 27 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-14k)
- add mkinitrd-3.0.9-ext3.patch for ext3 filesystem

* Wed Sep 26 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-12k)
- modifie mkinitrd-3.0.9-filesystem.modules.patch and mkinitrd-3.0.9-ataraid.patch correctly

* Mon Sep 24 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-10k)
- add mkinitrd-3.0.9-filesystem.modules.patch to treat modules of / and /lib file system
- modify mkinitrd-3.0.9-ataraid.patch

* Fri Aug 31 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-8k)
- add mkinitrd-3.0.9-ataraid.patch for ATA RAID card

* Fri Jun 29 2001 Toru Hoshina <toru@df-usa.com>
- (3.0.9-6k)
- add alphaev5 support.

* Sat Apr  7 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-4k)
- add mkinit.noide.patch

* Thu Apr  5 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (3.0.9-2k)
- backport from Jirai

* Wed Mar 28 2001 Toru Hoshina <toru@df-usa.com>
- (3.0.9-3k)
- turned off mkinitrd-2.6-imagesize.patch, because IMAGESIZE has been
  expanded to 3000.

* Wed Feb 28 2001 Matt Wilson <msw@redhat.com>
- changed the Requires on mktemp from >= 1.5 to >= 1.5-5 (which included
  -d support) (#30127)

* Fri Feb 23 2001 Erik Troan <ewt@redhat.com>
- let nash be invoked as modprobe to avoid a modprobe failure to exec
- nash will try to run arbitrary commands now (removing insmod as a special 
  case)

* Mon Feb 12 2001 Matt Wilson <msw@redhat.com>
- add findutils to Requires line (#27269)

* Thu Feb  8 2001 Matt Wilson <msw@redhat.com>
- added checks to load the modules i2o_block needs

* Wed Feb  7 2001 Bill Nottingham <notting@redhat.com>
- fix utterly broken build

* Wed Jan 31 2001 Helge Deller <hdeller@redhat.com>
- added mandir to nash Makefile (RH 6.x compatibility) 

* Tue Jan 30 2001 Erik Troan <ewt@redhat.com>
- added dependency on mktemp

* Thu Jan 25 2001 Erik Troan <ewt@redhat.com>
- we need to insert xor.o before raid5.o

* Wed Jan 24 2001 Matt Wilson <msw@redhat.com>
- code in RAID_AUTORUN ioctl fallback
- fixed raidstart check flag from -z to -n

* Tue Jan 23 2001 Erik Troan <ewt@redhat.com>
- switched to using nash from sash

* Tue Jan 23 2001 Matt Wilson <msw@redhat.com>
- added patch from twaugh to avoid blindly adding scsi_mod
  and sd_mod to initrd if they are not needed (#24114)

* Mon Jan 22 2001 YAMAGUCHI Kenji <yamk@sophiaworks.com>
- (mkinitrd-2.6-7k)
- added patch: mkinitrd-2.6-imagesize.patch (IMAGESIZE 1500->2000)
- changed Requires fullpath to Packagename.

* Thu Jan 11 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Enlarge initrds, needed for systems with both IDE and SCSI
  (Bug #23846)
- Version 2.[6789] probably shouldn't identify itself as 2.6
  with --version. ;)
- bzip2 source

* Wed Dec 20 2000 Erik Troan <ewt@redhat.com>
- let the kernel autoload ide-cd

* Fri Dec 08 2000 Erik Troan <ewt@redhat.com>
- added modular ide support

* Thu Nov 03 2000 YAMAGUCHI Kenji <yamk@sophiaworks.com>
- (mkinitrd-2.6-2k)
- changed nosrc.rpm to src.rpm

* Wed Nov 02 2000 YAMAGUCHI Kenji <yamk@sophiaworks.com>
- (mkinitrd-2.6-1k)
- Based on RedHat 7, mkinitrd-2.6-1
- fixed %description, "/etc/conf.modules" to "/etc/modules.conf"
- already fixed for FHS, then removed mkinitrd.fhs.patch
- a little Kondarize.
- appeded i586, i686 to ExclusiveArch:

* Wed Aug 30 2000 Nalin Dahyabhai <nalin@redhat.com>
- use mktemp to create temporary files and directories

* Sat Aug 05 2000 Erik Troan <ewt@redhat.com>
- changes from Keith Owens for 2.4

* Tue Jul  4 2000 Matt Wilson <msw@redhat.com>
- build on alpha

* Mon Jun 26 2000 Bill Nottingham <notting@redhat.com>
- ignore 'unknown' aliases (they shouldn't be there anyways)

* Thu Jun  1 2000 Bill Nottingham <notting@redhat.com>
- build on ia64
- bump up initrd size on ia64
- modules.confiscation, /usr/man -> /usr/share/man

* Tue May  2 2000 Nalin Dahyabhai <nalin@redhat.com>
- make RPM pick up man page, regardless of compression

* Tue Feb 29 2000 Matt Wilson <msw@redhat.com>
- add requirement for /sbin/losetup

* Mon Feb  7 2000 Matt Wilson <msw@redhat.com>
- gzip manpage

* Thu Feb  3 2000 Matt Wilson <msw@redhat.com>
- gzip manpage

* Mon Jan 10 2000 Erik Troan <ewt@redhat.com>
- use sash, not ash

* Mon Jan  3 2000 Matt Wilson <msw@redhat.com>
- use ash.static for /bin/sh, not sash

* Sat Jan 1 2000 Erik Troan <ewt@redhat.com>
- configure loopback devices

* Tue Sep 28 1999 Bill Nottingham <notting@redhat.com>
- sparc fixup from jakub

* Wed Sep 22 1999 Michael K. Johnson <johnsonm@redhat.com>
- fix cleanup (blush!)

* Tue Sep 21 1999 Michael K. Johnson <johnsonm@redhat.com>
- now works when /usr is not mounted (do not rely on /usr/bin/install)
- slight cleanups, better usage message

* Thu Jul 29 1999 Michael K. Johnson <johnsonm@redhat.com>
- Now automatically includes necessary raid modules
- --omit-raid-modules now omits raid modules
- tiny doc updates

* Thu Jul 29 1999 Bill Nottingham <notting@redhat.com>
- updates from bugzila (#4243, #4244)

* Sat Mar 27 1999 Matt Wilson <msw@redhat.com>
- --omit-scsi-modules now omits all scsi modules
- updated documentation
- mkinitrd now grabs scsi_hostadapter modules from anywhere -
  some RAID controller modules live in block/

* Thu Feb 25 1999 Matt Wilson <msw@redhat.com>
- updated description

* Mon Jan 11 1999 Matt Wilson <msw@redhat.com>
- Ignore the absence of scsi modules, include them if they are there, but
  don't complain if they are not.
- changed --no-scsi-modules to --omit-scsi-modules (as it should have been)

* Thu Nov  5 1998 Jeff Johnson <jbj@redhat.com>
- import from ultrapenguin 1.1.

* Tue Oct 20 1998 Jakub Jelinek <jj@ultra.linux.cz>
- fix for combined sparc/sparc64 insmod, also pluto module is really
  fc4:soc:pluto and we don't look at deps, so special case it.

* Sat Aug 29 1998 Erik Troan <ewt@redhat.com>
- replaced --needs-scsi-mods (which is now the default) with
  --omit-scsi-mods

* Fri Aug  7 1998 Jeff Johnson <jbj@redhat.com>
- correct obscure regex/shell interaction (hardwires tabs on line 232)

* Mon Jan 12 1998 Erik Troan <ewt@redhat.com>
- added 'make archive' rule to Makefile
- rewrote install procedure for more robust version handling
- be smarter about grabbing options from /etc/conf.modules

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- made it use /bin/ash.static

* Wed Apr 16 1997 Erik Troan <ewt@redhat.com>
- Only use '-s' to install binaries if /usr/bin/strip is present.
- Use an image size of 2500 if binaries can't be stripped (1500 otherwise)
- Don't use "mount -o loop" anymore -- losetup the proper devices manually
- Requires losetup, e2fsprogs

* Wed Mar 12 1997 Michael K. Johnson <johnsonm@redhat.com>
- Fixed a bug in parsing options.
- Changed to use a build tree, then copy the finished tree into the
  image after it is built.
- Added patches derived from ones written by Christian Hechelmann which
  add an option to put the kernel version number at the end of the module
  name and use install -s to strip binaries on the fly.
